#!/usr/bin/python

"you can email me at: emmanuel.nsanga@gmail.com"

"""Copyright [2013] [Emmanuel Nsanga]

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License."""

import subprocess, sys, os, shelve, urllib2, imaplib
from gi.repository import Gtk

doc = """usage: ./installer.py or python installer.py followed by the text file directory, e.g "python installer.py /home/emmanuel/install.txt".
         and in the text file, specify if the installer you need to use by denoting "easy:" if its "easy_install" or "pip:" if its python-pip,
         and if its in the standard library you don't need to denote anything, e.g "ipython
                                                                                    docky
                                                                                    chromium-browser
                                                                                    pip: beautifulsoup4
                                                                                    easy: beautifulsoup4"
                                                                                                        """



class GuiIns():
    def __init__(self):
        fi = "gui.glade"
        build = Gtk.Builder()
        build.add_from_file(fi)
        build.connect_signals(self)
        build.get_object("window1").show_all()

    def on_window1_destroy_event(self, widget):
        print "Quiting"
        Gtk.main_quit()

    def on_button1_clicked(self, widget):
        pass




def email():
    global email, install, settings
    mail = imaplib.IMAP4_SSL('imap.gmail.com' )
    mail.login('email', 'password')
    mail.list()
    mail.select('install')
    results, data = mail.search(None, "ALL")

    ids = data[0]
    id_list = ids.split()
    latest_email_id = id_list[-1]
    result, data = mail.fetch(latest_email_id, "(RFC822)")
    raw = data[0][1]

    ind = []
    ls = raw.split('\n')
    for d in ls:
        if "--" in d:
            i = ls.index(d)
            ind.append(i)
            ls.pop(i)

    lss = raw.split('\n')
    par = []
    for dd in range(ind[0]+3, ind[1]):
        po = lss[dd]
        par.append(po)


    print par


def install():
    a = open(txt[0], "r").read()
    if "pip:" in a:
        try:
            subprocess.check_output("pip --version", shell=True)

        except:
            os.system("sudo apt-get install python-pip -y;sudo killall -9 apt-get")

    elif "easy:" in a:
        try:
            subprocess.check_output("easy_install --version", shell=True)

        except:
            os.system("wget https://bitbucket.org/pypa/setuptools/raw/0.7.2/ez_setup.py -O - | python")

    re = subprocess.check_output("lsb_release -sc -a", shell=True)
    rel = subprocess.check_output("lsb_release -sc -c", shell=True)
    for dd in a.split(','):
        if "ppa:" in dd:
            if "Mint" in re:
                fi = open("/usr/share/mintsources/%s/mintsources.conf" %rel.replace('\n', ''), "r")
                fil = fi.read()
                for it in fil.split('\n'):
                    if "base_codename" in it:
                        code = it.split('=')[1]

                fi.close()

            else:
                code = rel.replace('\n', '')

            dda = dd.split(":")
            bin = "deb http://ppa.launchpad.net/"+dda[2].replace(' ', '').replace('\n', '')+"/ubuntu %s main" %code.replace(' ', '')
            src = bin.replace("deb", "deb-src").replace('\n', '')
            tr = dda[2].replace('/', '-').replace('\n', '')+"-%s.list"%code.replace(' ', '')

            try:
                print tr
                apt = open("/etc/apt/sources.list.d/%s"%tr, "r")
                source = apt.read()
                sh = shelve.open("ppa.db", writeback=True)
                shh = sh[tr] = source
                sh.sync()
                apt.close()

            except:
                ur = dda[2].replace(' ', '').replace('\n', '').split('/')
                url = "https://launchpad.net/~%s/+archive/%s" %(ur[0], ur[1])
                htm = urllib2.urlopen(url).read()
                ite = []
                for itt in htm.split('\n'):
                    if "<code>" in itt:
                        ite.append(itt)

                print url, ite
                key = str(ite).split('/')[1].replace('<', '')
                print "sdf"
                os.system("sudo apt-key adv --keyserver keyserver.ubuntu.com --recv-keys %s" %key)

                print "Sdf"
                with open("/etc/apt/sources.list.d/%s"%tr.replace('\n', '').replace(' ', ''), "w") as fin:
                    fin.write("%s\n" %bin)
                    fin.write("%s\n" %src)

    if len(ppa) > 0:
        os.system("sudo apt-get update")

    for d in a.split(','):
        if "pip:" in d:
            da = d.split(':')
            os.system("sudo pip install %s" %da[1].replace(' ', ''))

        elif "easy:" in d:
            dan = d.split(':')
            os.system("sudo easy_install %s" %dan[1].replace(' ', ''))

        elif "ppa:" not in d:
            os.system("sudo killall -9 apt-get;sudo apt-get install %s" %d)




def settings(a, c):
    os.system("mkdir backup")
    ff = open(a, "r").read()
    fi = (len(a.split("/"))-1)
    b = open("backup/%s"%fi, "w")
    b.write(ff)
    b.close()

    f = open(a, "w")
    f.write(c)
    f.close()


def main():
    ar = sys.argv[1:]
    if len(ar) > 0:
        if "-e" in ar[0]:
            e = email()
            install(e)

        elif "-t" in ar[0]:
            a = open(ar[1], "r").read()
            p = []
            for d in a.split('\n'):
                p.append(d)

            install(p)

        else:
            print doc

    else:
        print "Running Gui..."
        Gui = GuiIns()
        Gtk.main()


if __name__ == '__main__':
    main()
